void renderScene(void)
{
	if (mouseActive==1)
	{
		POINT val = mouse.getRelativeMovement();
		cameraControl.mouseTurn(val.x);
		cameraControl.mouseTilt(-val.y);
	}
	cameraControl.checkCurrentMovement();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
	if (isGridActive) drawOrigin();
	glPopMatrix();
	
    //******************** Hier den Code einfgen! ********************


	draw_space();
	draw_earth();
	for ( int i = 0; i < max_moon_parts; i++ )
	{
		draw_moon_part(moon_parts[i]);
	}


	Timer_refresh();

	for ( int millisekunden = 0; millisekunden < Timer_Time_passed_ms * time_multiplikator; millisekunden ++ )
	{
		if ( moon_am_aufladen ) moon_aufladen();
		else {
			calc_stuff();
			move_moon_parts();
			//move_earth();
			rotate_earth();
		}		
	}	
	
	
	//*****************************************************************
	
	glutSwapBuffers();
}




float zufallszahl( float ende )
{
	float wert;
	wert = ( rand() * ende ) / 32767;
	return wert;
}



void anschubsen()
{
	for ( int i = 0; i < max_moon_parts; i++ )
	{
		moon_parts[i].vel.x += zufallszahl(1000) / 1000;
		moon_parts[i].vel.y += zufallszahl(1000) / 1000;
		moon_parts[i].vel.z += zufallszahl(1000) / 1000;

		moon_parts[i].vel.x -= zufallszahl(1000) / 1000;
		moon_parts[i].vel.y -= zufallszahl(1000) / 1000;
		moon_parts[i].vel.z -= zufallszahl(1000) / 1000;
	}
}






void moon_reset()
{
	earth.pos.x = 0;
	earth.pos.y = 0;
	earth.pos.z = 0;
	earth.vel.x = 0;
	earth.vel.y = 0;
	earth.vel.z = 0;
	earth.rot.x = -78;

	for ( int i = 0; i < max_moon_parts; i++ )
	{
		moon_parts[i].pos.x = 1.3 + i * federlaenge;
		moon_parts[i].pos.y = 0;
		moon_parts[i].pos.z = 0;
		moon_parts[i].vel.x = 0;
		moon_parts[i].vel.y = mond_start_speed;
		moon_parts[i].vel.z = 0;
	}	
}

void init_moon_parts(void)
{
	srand( (unsigned)time( NULL ) );
//	s3dvect zufalls_axe;  // fuer das lot produkt fuer die tangentialgeschwindigkeit	
	for ( int i = 0; i < max_moon_parts; i++ )
	{

		moon_parts[i].radius = 0.1;
		moon_parts[i].mass = moon_parts[i].radius * moon_parts[i].radius * moon_parts[i].radius * 0.001;
	}

	earth.radius = 0.3;
	earth.mass = earth.radius * earth.radius * earth.radius * 100;

	moon_reset();
}

void main(int argc, char *argv[])
{
	init_moon_parts();

	TimerInit();

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowPosition(100, 100);
	glutInitWindowSize(800, 600);	
	glutCreateWindow("Tobias Hermann");

	tgaGetColorEXT();
	glColorMaterial ( GL_FRONT, GL_AMBIENT_AND_DIFFUSE );

77	glEnable      ( GL_TEXTURE_2D );
//	glPixelStorei ( GL_UNPACK_ALIGNMENT, 1 );

	cameraControl.eyePosZ = 5;

		N = 64;
		dt = 0.1f;
		diff = 0.0f;
		visc = 0.0f;
		force = 5.0f;
		source = 100.0f;

	initEnvironment();
	glutMainLoop();
}

void initEnvironment(void)
{
	glutDisplayFunc(renderScene);
	glutIdleFunc(renderScene);
	glutReshapeFunc(changePerspective);
	glutIgnoreKeyRepeat(1);
	glutKeyboardFunc(normalKeyPressed);
	glutKeyboardUpFunc(normalKeyReleased);
	glutSpecialFunc(specialKeyPressed);
	glutSpecialUpFunc(specialKeyReleased);
	//glEnable(GL_TEXTURE_2D);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);
}



void changePerspective(int width, int height)
{
	if (height == 0) height = 1;
	float ratio = 1.0f * width / height;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0, 0, width, height);
	gluPerspective(45.0f, ratio, 0.1f, 1000.0f);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	cameraControl.updateCamera();
}