float vector_length(s3dvect a)
{
	return (float) sqrt(a.x * a.x + a.y * a.y + a.z * a.z);
}

s3dvect normalized_vector(s3dvect a)
{
	s3dvect result;
	float length;
	length = vector_length(a);
	if (length > 0)
	{
		result.x = a.x / length; 
		result.y = a.y / length;
		result.z = a.z / length;
	}
	return result;
}

s3dvect add_vector(s3dvect a, s3dvect b)
{
	a.x += b.x;
	a.y += b.y;
	a.z += b.z;
	return a;
}

s3dvect sub_vector(s3dvect a, s3dvect b)
{
	a.x -= b.x;
	a.y -= b.y;
	a.z -= b.z;
	return a;
}

s3dvect mult_vector(s3dvect a, float faktor)
{	
	a.x *= faktor;
	a.y *= faktor;
	a.z *= faktor;
	return a;
}

s3dvect div_vector(s3dvect a, float divisor)
{	
	a.x /= divisor;
	a.y /= divisor;
	a.z /= divisor;
	return a;
}

s3dvect negative_vector(s3dvect a)
{
	s3dvect help;
	help.x = - a.x;
	help.y = - a.y;
	help.z = - a.z;
	return help;
}

s3dvect cross_product(s3dvect a, s3dvect b)
{
	s3dvect help;
	help.x =   (a.y * b.z - a.z * b.y);
	help.y = - (a.x * b.z - a.z * b.x);
	help.z =   (a.x * b.y - a.y * b.x);
	return help;
}

float dot_product(s3dvect a, s3dvect b)
{
	float help;
	help = a.x * b.x + a.y * b.y + a.z * b.z;
	return help;
}

s3dvect lot_vector(s3dvect a, s3dvect b)
{
	s3dvect result;
	result = cross_product(a,b);
	result = normalized_vector(result);
	return result;
}