void calc_grav(s3dmasspoint *az, s3dmasspoint *bz)
{
	s3dmasspoint a,b;
	a = *az;
	b = *bz;
	s3dvect diff = sub_vector ( a.pos, b.pos ); // zeigt von b nach a
	float  dist = vector_length ( diff );
	s3dvect dir = normalized_vector ( diff );

	// normalerweise jetz beide massen
	// aber: a = f / m
	s3dvect acc_a = mult_vector( dir, ( ( gravitationskonstante * b.mass ) / ( (dist * dist) ) ) ) ;
	s3dvect acc_b = mult_vector( dir, ( ( gravitationskonstante * a.mass ) / ( (dist * dist) ) ) ) ;
	acc_a = negative_vector(acc_a);
	a.vel = add_vector( a.vel, acc_a );
	b.vel = add_vector( b.vel, acc_b );
	//a.vel = add_vector( a.vel, acc_a );
	//b.vel = add_vector( b.vel, acc_b );

	*az = a;
	*bz = b;
}


void calc_feder(s3dmasspoint *az, s3dmasspoint *bz)
{
	s3dmasspoint a,b;
	a = *az;
	b = *bz;
	s3dvect diff = sub_vector ( a.pos, b.pos ); // zeigt von b nach a
	float  dist = vector_length ( diff );
	s3dvect dir = normalized_vector ( diff );
	s3dvect divv = sub_vector ( a.vel, b.vel );
	float speed_div;
	//speed_div = dot_product( dir, divv );
	speed_div = vector_length ( divv );

	dist -= federlaenge;  // da die feder auch gestaucht werden kann: - natuerliche federlnge

	s3dvect acc_a = mult_vector( dir, (dist*federkonstante) ) ;
	s3dvect acc_b = mult_vector( dir, (dist*federkonstante) ) ;
	acc_a = negative_vector(acc_a);

	//daempfung
	acc_a = sub_vector ( acc_a, mult_vector ( divv, speed_div*daempfung ) );
	acc_b = sub_vector ( acc_b, mult_vector ( divv, -speed_div*daempfung ) );

	a.vel = add_vector( a.vel, div_vector( acc_a, max_moon_parts ) );
	b.vel = add_vector( b.vel, div_vector( acc_b, max_moon_parts ) );	

	*az = a;
	*bz = b;
}



void calc_stuff()
{
	int i;	
	for ( i = 0; i < max_moon_parts-1; i ++ )
	{
		for ( int j = i+1; j < max_moon_parts; j ++ )
		{
			calc_feder(&moon_parts[i],&moon_parts[j]);
			//calc_stab(&moon_parts[i],&moon_parts[j]);
		}
	}	
	for ( i = 0; i < max_moon_parts; i ++ )
	{
		if ( !moon_am_aufladen ) calc_grav(&moon_parts[i],&earth);
	}
}

void move_moon_parts()
{
	for ( int i = 0; i < max_moon_parts; i ++ )
	{
		//moon_parts[i].pos = add_vector ( moon_parts[i].pos, mult_vector(moon_parts[i].vel, Timer_Time_passed) ) ;
		moon_parts[i].pos = add_vector ( moon_parts[i].pos, mult_vector(moon_parts[i].vel, 0.001) ) ;
	}
}

void move_earth()
{
	earth.pos = add_vector ( earth.pos, earth.vel );	
}

void rotate_earth()
{
	earth.rot.z += 0.01;
}

void moon_aufladen()
{
	moon_am_aufladen = true;
	moon_parts[0].vel.y += 0.001 * moon_auflade_richtung;
	moon_parts[1].vel.y -= 0.001 * moon_auflade_richtung;
}