//*****************************************************************************************
//*****************************************************************************************
//*                   CCameraControl 1.0 (C) Blackwidow and Finalbrain                    *
//*****************************************************************************************
//*****************************************************************************************

// Turning
#define TURNING_STEP	0.01f
#define TURN_LEFT		-1
#define TURN_RIGHT		1
#define STOP_TURNING	0
// Tilting
#define TILTING_STEP	0.01f
#define TILTING_MAX		1.57f				//  PI/2
#define TILTING_MIN		-1.57f				// -PI/2
#define TILT_UP			1
#define TILT_DOWN		-1
#define STOP_TILTING	0
// Walking
#define WALKING_STEP	0.1f
#define WALK_FORWARD	1
#define WALK_BACKWARD	-1
#define STOP_WALKING	0
// Flying
#define FLYING_STEP		0.1f
#define FLY_FORWARD		1
#define FLY_BACKWARD	-1
#define STOP_FLYING		0
// Strafing
#define STRAFING_STEP	0.1f
#define STRAFE_LEFT		1
#define STRAFE_RIGHT	-1
#define STOP_STRAFING	0
// Hovering
#define HOVERING_STEP	0.1f
#define HOVER_UP		1
#define HOVER_DOWN		-1
#define STOP_HOVERING	0

class CCameraControl
{
	public:
		CCameraControl();
		
		void updateCamera();
		void checkCurrentMovement();

		void turnLeft();
		void turnRight();
		void stopTurning();

		void tiltUp();
		void tiltDown();
		void stopTilting();

		void walkForward();
		void walkBackward();
		void stopWalking();

		void flyForward();
		void flyBackward();
		void stopFlying();

		void strafeLeft();
		void strafeRight();
		void stopStrafing();

		void hoverUp();
		void hoverDown();
		void stopHovering();

		void mouseTurn(int pixels);
		void mouseTilt(int pixels);
	
	public:
		float eyePosX, eyePosY, eyePosZ;
		float turnViewAngle, tiltViewAngle;
		float lineOfSightX, lineOfSightY, lineOfSightZ;
		int viewIsTurning, viewIsTilting, turningCache, tiltingCache;
		int isWalking, isFlying, isStrafing, isHovering, walkingCache, flyingCache, strafingCache, hoveringCache;

		void initPerspective();
		void turnView(int steps);
		void tiltView(int steps);
		void walk(int steps);
		void fly(int steps);
		void strafe(int steps);
		void hover(int steps);
};
