void normalKeyPressed(unsigned char key, int x, int y)
{
	switch (key)
	{
		//Programm mit ESC beenden
		case 27:
			exit(0);
			break;
		// KAMERA Steuerung
		case 'w':
			cameraControl.walkForward();
			break;
		
		case 's':
			cameraControl.walkBackward();
			break;
		
		case 'W':
			cameraControl.flyForward();
			break;
		
		case 'S':
			cameraControl.flyBackward();
			break;
		
		case 'a':
			cameraControl.strafeLeft();
			break;
		
		case 'd':
			cameraControl.strafeRight();
			break;

		case 'e':
			anschubsen();
			break;

		case 't':
			moon_am_aufladen = true;
			moon_auflade_richtung = +1;
			moon_reset();
			break;

		case 'r':
			moon_am_aufladen = true;
			moon_auflade_richtung = -1;
			moon_reset();
			break;

		case '+':
			if ( time_multiplikator < 10 ) time_multiplikator++;
			break;

		case '-':
			if ( time_multiplikator > 1 ) time_multiplikator--;
			break;
	}
}

void normalKeyReleased(unsigned char key, int x, int y)
{
	switch (key)
	{
		// KAMERA Steuerung
		case 'w':
		case 'W':
		case 's':
		case 'S':
			cameraControl.stopWalking();
			cameraControl.stopFlying();
			break;
		
		case 'a':
		case 'A':
		case 'd':
		case 'D':
			cameraControl.stopStrafing();
			break;
		case 'r':
			moon_am_aufladen = false;
			break;
		case 't':
			moon_am_aufladen = false;
			break;
		case 'g':
			if (isGridActive)
				isGridActive = 0;
			else
				isGridActive = 1;
			break;

		case ' ':
			if (mouseActive == 1)
			{
				glutSetCursor(GLUT_CURSOR_LEFT_ARROW);
				mouseActive = 0;
			}
			else
			{
				glutSetCursor(GLUT_CURSOR_NONE);
				mouseActive = 1;
			}
			break;	
	}
}

void specialKeyPressed(int key, int x, int y)
{
	int modifiers = glutGetModifiers();

	switch (key)
	{
		// Zwischen Fullscreen und Window wechseln
		case GLUT_KEY_F11:
			if (glutGameModeGet(GLUT_GAME_MODE_ACTIVE))
			{
				glutLeaveGameMode();
			}
			else
			{
				glutGameModeString(GAMEMODE_STRING);
				if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE))
				{
					glutEnterGameMode();

					if (mouseActive == 1)
						glutSetCursor(GLUT_CURSOR_NONE);
					else
						glutSetCursor(GLUT_CURSOR_LEFT_ARROW);
										
					mouse.resetMouse();
					initEnvironment();
				}
				else
					exit(1);
			}
			break;
		
		// KAMERA Steuerung
		case GLUT_KEY_LEFT:
			cameraControl.turnLeft();
			break;
		
		case GLUT_KEY_RIGHT:
			cameraControl.turnRight();
			break;
		
		case GLUT_KEY_UP:
			cameraControl.tiltUp();
			break;
		
		case GLUT_KEY_DOWN:
			cameraControl.tiltDown();
			break;

		case GLUT_KEY_PAGE_UP:
			cameraControl.hoverUp();
			break;
		
		case GLUT_KEY_PAGE_DOWN:
			cameraControl.hoverDown();
			break;
	}
}

void specialKeyReleased(int key, int x, int y)
{
	switch (key)
	{
		// KAMERA Steuerung
		case GLUT_KEY_LEFT:
		case GLUT_KEY_RIGHT:
			cameraControl.stopTurning();
			break;
		
		case GLUT_KEY_UP:
		case GLUT_KEY_DOWN:
			cameraControl.stopTilting();
			break;
		
		case GLUT_KEY_PAGE_UP:
		case GLUT_KEY_PAGE_DOWN:
			cameraControl.stopHovering();
			break;
	}
}